import { EquipmentSlot, GameMode, ItemStack, system, world } from "@minecraft/server";
import { randomRange } from "../util";
const ItemAges = {};
export var Drops;
(function (Drops) {
    const itemMappings = new Map();
    const jData = '{"data":[{"from":"spark:acacia_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:acacia_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:acacia_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:acacia_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:birch_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:birch_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:birch_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:birch_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:cherry_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:cherry_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:cherry_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:cherry_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:dark_oak_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:dark_oak_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:dark_oak_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:dark_oak_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:jungle_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:jungle_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:jungle_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:jungle_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:mangrove_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:mangrove_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:mangrove_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:mangrove_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:oak_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:oak_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:oak_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:oak_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:spruce_branch_slab","to":"minecraft:stick","min":0,"max":1},{"from":"spark:spruce_branch_slab_up","to":"minecraft:stick","min":0,"max":1},{"from":"spark:spruce_branch_slant","to":"minecraft:stick","min":0,"max":1},{"from":"spark:spruce_branch_stair","to":"minecraft:stick","min":0,"max":1},{"from":"spark:log_big_oak_mossy_1","to":"minecraft:dark_oak_log","matchDroppedAmount":true},{"from":"spark:log_birch_mossy_1","to":"minecraft:birch_log","matchDroppedAmount":true},{"from":"spark:log_jungle_mossy_1","to":"minecraft:jungle_log","matchDroppedAmount":true},{"from":"spark:log_oak_frost","to":"minecraft:oak_log","matchDroppedAmount":true},{"from":"spark:log_oak_mossy_1","to":"minecraft:oak_log","matchDroppedAmount":true},{"from":"spark:log_spruce_frost","to":"minecraft:spruce_log","matchDroppedAmount":true},{"from":"spark:log_spruce_frost_1","to":"minecraft:spruce_log","matchDroppedAmount":true},{"from":"spark:log_spruce_mossy_1","to":"minecraft:spruce_log","matchDroppedAmount":true},{"from":"spark:rowan_covered","to":"spark:rowan","min":1,"max":1},{"from":"spark:tree_base_big_oak_mossy","to":"minecraft:dark_oak_log","matchDroppedAmount":true},{"from":"spark:tree_base_birch_mossy","to":"minecraft:birch_log","matchDroppedAmount":true},{"from":"spark:tree_base_jungle_mossy","to":"minecraft:jungle_log","matchDroppedAmount":true},{"from":"spark:tree_base_mangrove_mossy","to":"minecraft:mangrove_log","matchDroppedAmount":true},{"from":"spark:tree_base_oak_mossy","to":"minecraft:oak_log","matchDroppedAmount":true},{"from":"spark:tree_base_spruce_mossy","to":"minecraft:spruce_log","matchDroppedAmount":true}]}';
    function init() {
        // does nothing much...
        loadFromJSON();
        system.runInterval(tick, 1);
    }
    Drops.init = init;
    function loadFromJSON() {
        let d = JSON.parse(jData);
        for (const data of d.data) {
            if (itemMappings.has(data.from))
                return;
            let t = {
                delete: false
            };
            if (data.delete != undefined) {
                if (data.delete == true)
                    t.delete = true;
            }
            if (data.to != undefined)
                t.type = data.to;
            if (data.amount != undefined)
                t.amount = data.amount;
            if (data.matchDroppedAmount != undefined)
                t.matchDroppedStack = data.matchDroppedAmount;
            if (data.min != undefined)
                t.min = data.min;
            if (data.max != undefined)
                t.max = data.max;
            itemMappings.set(data.from, t);
        }
    }
    function tick() {
        // get all items in the game world
        // get their type and if they match, replace
        let overworld = world.getDimension("overworld").getEntities({ type: "minecraft:item" });
        let nether = world.getDimension("nether").getEntities({ type: "minecraft:item" });
        let end = world.getDimension("the_end").getEntities({ type: "minecraft:item" });
        // might be fine :D
        let items = [...overworld, ...nether, ...end];
        for (const item of items) {
            // if (!item.isOnGround) continue;
            transformItem(item);
            // Track item age
            ItemAges[item.id] = (ItemAges[item.id] || 0) + 1;
        }
    }
    function transformItem(item) {
        if (!item.hasComponent("minecraft:item"))
            return;
        let comp = item.getComponent("minecraft:item");
        let droppedItem = comp.itemStack.typeId;
        let droppedItemAmount = comp.itemStack.amount;
        if (itemMappings.has(droppedItem)) {
            let data = itemMappings.get(droppedItem);
            let loc = item.location;
            // teleport old item away
            // item.teleport({ x: item.location.x, y: -64, z: item.location.z });
            if (data.delete) {
                item.kill();
                return;
            }
            if (data.matchDroppedStack != undefined) {
                if (data.matchDroppedStack == true) {
                    // spawn new item
                    let newItem = new ItemStack(data.type, droppedItemAmount);
                    item.dimension.spawnItem(newItem, loc);
                    item.kill();
                    return;
                }
            }
            if (data.amount != undefined) {
                // spawn new item
                let newItem = new ItemStack(data.type, data.amount);
                item.dimension.spawnItem(newItem, loc);
                item.kill();
                return;
            }
            if (data.min != undefined && data.max != undefined) {
                // spawn new item
                let r = randomRange(data.min, data.max);
                if (r == 0) {
                    item.kill();
                    return;
                }
                let newItem = new ItemStack(data.type, r);
                item.dimension.spawnItem(newItem, loc);
                item.kill();
                return;
            }
        }
    }
})(Drops || (Drops = {}));
const ShearableBlocks = [
    'spark:acorus',
    'spark:bracken_jungle_small',
    'spark:bracken_jungle',
    'spark:bracken',
    'spark:bush_cold_small',
    'spark:bush_cold',
    'spark:bush_dark_small',
    'spark:bush_dark',
    'spark:bush_desert_small',
    'spark:bush_desert',
    'spark:bush_forest_small',
    'spark:bush_forest',
    'spark:bush_jungle_small',
    'spark:bush_jungle',
    'spark:bush_pink_small',
    'spark:bush_pink',
    'spark:bush_rosa_small',
    'spark:bush_rosa',
    'spark:bush_savanna_small',
    'spark:bush_savanna',
    'spark:bush_snow_covered',
    'spark:bush_snow_small_covered',
    'spark:bush_snow_small',
    'spark:bush_snow',
    'spark:bush_swamp_small',
    'spark:bush_swamp',
    'spark:cattail',
    'spark:dry_plant',
    'spark:giant_nasturtium',
    'spark:ground_branch_acacia',
    'spark:ground_branch_big_oak',
    'spark:ground_branch_birch',
    'spark:ground_branch_cherry',
    'spark:ground_branch_crimson',
    'spark:ground_branch_jungle',
    'spark:ground_branch_mangrove',
    'spark:ground_branch_oak',
    'spark:ground_branch_spruce',
    'spark:ground_branch_warped',
    'spark:ground_leaves_acacia',
    'spark:ground_leaves_big_oak',
    'spark:ground_leaves_birch',
    'spark:ground_leaves_cherry',
    'spark:ground_leaves_crimson',
    'spark:ground_leaves_jungle',
    'spark:ground_leaves_mangrove',
    'spark:ground_leaves_oak',
    'spark:ground_leaves_spruce',
    'spark:ground_leaves_warped',
    'spark:jungle_clover',
    'spark:lily_pad_big',
    'spark:lily_pad_flowering',
    'spark:long_leaf_plant',
    'spark:monstera',
    'spark:moss_hanging',
    'spark:mushroom_cluster_big_red',
    'spark:mushroom_cluster_big',
    'spark:mushroom_cluster_red',
    'spark:mushroom_cluster',
    'spark:mushroom_shelf_1',
    'spark:mushroom_shelf_2',
    'spark:mushroom_shelf_3',
    'spark:philodendron',
    'spark:ponysfoot',
    'spark:reed',
    'spark:sowthistle',
    'spark:spider_plant',
    'spark:venus_flytrap',
];
world.afterEvents.playerBreakBlock.subscribe(event => {
    var _a;
    if (!event.player.matches({ gameMode: GameMode.survival }))
        return;
    function getOldItem() {
        let entities = event.dimension.getEntitiesAtBlockLocation(event.block.location);
        for (let entity of entities) {
            if (entity.typeId == 'minecraft:item') {
                if (ItemAges[entity.id] > 2)
                    continue;
                return entity;
            }
        }
        return null;
    }
    function spawnNewItem(id) {
        event.dimension.spawnItem(new ItemStack(id, 1), event.block.bottomCenter());
    }
    // Transform item in case of silk touch
    let equip_component = event.player.getComponent('minecraft:equippable');
    let held_item_id = (_a = equip_component.getEquipment(EquipmentSlot.Mainhand)) === null || _a === void 0 ? void 0 : _a.typeId;
    let shearable_id = ShearableBlocks.find(id => event.brokenBlockPermutation.matches(id));
    if (shearable_id && held_item_id) {
        let old_item = getOldItem();
        if (held_item_id == 'minecraft:shears') {
            // Shears
            if (old_item)
                old_item.remove();
            spawnNewItem(shearable_id);
        }
        else if (held_item_id && old_item) {
            // Silk Touch
            let item_component = old_item.getComponent('minecraft:item');
            let item_id = item_component.itemStack.typeId;
            if (item_id == shearable_id) {
                old_item.remove();
            }
        }
    }
});
