import { world } from "@minecraft/server";
import { randomRange } from "../util";
// this only works with the 
export var Sapling;
(function (Sapling) {
    const spruceArray = [{ "structure": "mystructure:spark/t/pine_s_0", "x_off": 2, "z_off": 2, "size": [5, 11, 5] }, { "structure": "mystructure:spark/t/pine_s_1", "x_off": 2, "z_off": 2, "size": [5, 11, 5] }, { "structure": "mystructure:spark/t/pine_s_2", "x_off": 2, "z_off": 2, "size": [5, 11, 5] }, { "structure": "mystructure:spark/t/pine_s_3", "x_off": 3, "z_off": 3, "size": [7, 13, 7] }, { "structure": "mystructure:spark/t/pine_s_4", "x_off": 3, "z_off": 3, "size": [7, 14, 7] }, { "structure": "mystructure:spark/t/pine_m_0", "x_off": 3, "z_off": 3, "size": [7, 15, 7] }, { "structure": "mystructure:spark/t/pine_m_1", "x_off": 3, "z_off": 3, "size": [7, 16, 7] }, { "structure": "mystructure:spark/t/pine_m_2", "x_off": 3, "z_off": 3, "size": [7, 17, 7] }, { "structure": "mystructure:spark/t/pine_m_3", "x_off": 3, "z_off": 3, "size": [7, 18, 7] }, { "structure": "mystructure:spark/t/pine_l_0", "x_off": 4, "z_off": 4, "size": [9, 20, 9] }, { "structure": "mystructure:spark/t/pine_l_1", "x_off": 4, "z_off": 4, "size": [9, 21, 9] }, { "structure": "mystructure:spark/t/pine_l_2", "x_off": 4, "z_off": 4, "size": [9, 22, 9] }];
    const blocksWhitelist = [
        "minecraft:air",
        "minecraft:leaves",
        "minecraft:leaves2",
        "minecraft:mangrove_leaves",
        "minecraft:sapling",
        "minecraft:cherry_sapling",
        "minecraft:cherry_leaves",
        "minecraft:azalea_leaves",
        "minecraft:azalea_leaves_flowered",
        "minecraft:tallgrass"
    ];
    function init() {
    }
    Sapling.init = init;
    function isSingleSapling(block, permutation, saplingType) {
        for (let x = -1; x < 2; x++) {
            for (let z = -1; z < 2; z++) {
                if (x == 0 && z == 0)
                    continue;
                let detectBlock = block.dimension.getBlock({ x: block.x + x, y: block.y, z: block.z + z });
                if (detectBlock.permutation.matches(permutation, { 'sapling_type': saplingType }))
                    return false;
            }
        }
        return true;
    }
    function isValidSpawnLocation(block, sx, sy, sz, ex, ey, ez) {
        for (let x = sx; x < ex; x++) {
            for (let y = sy; y < ey; y++) {
                for (let z = sz; z < ez; z++) {
                    // test for whitelisted types
                    if (!isBlockWhitelisted(block.dimension.getBlock({ x: x, y: y, z: z }))) {
                        return false;
                    }
                }
            }
        }
        return true;
    }
    function isBlockWhitelisted(block) {
        for (const s of blocksWhitelist) {
            if (block.permutation.matches(s))
                return true;
        }
        return false;
    }
    // events
    world.afterEvents.itemUseOn.subscribe((event) => {
        if (event.itemStack.typeId != "minecraft:bone_meal")
            return;
        // detect if block is spruce
        let block = event.block;
        if (!block.permutation.matches("minecraft:sapling", { 'sapling_type': "spruce" }))
            return;
        // 2x2 detect, if 1x1 continue
        if (!isSingleSapling(block, "minecraft:sapling", "spruce"))
            return;
        // choose growth pattern
        let pattern = spruceArray[randomRange(0, spruceArray.length - 1)];
        let sx = block.x - pattern.x_off;
        let sy = block.y;
        let sz = block.z - pattern.x_off;
        // check for 
        if (!isValidSpawnLocation(block, sx, sy, sz, sx + pattern.size[0], sy + pattern.size[1], sz + pattern.size[2]))
            return;
        event.source.sendMessage(pattern.structure);
        // spawn in strucure
        let cmd = `structure load "${pattern.structure}" ${sx} ${sy} ${sz}`;
        block.dimension.runCommandAsync(cmd);
    });
})(Sapling || (Sapling = {}));
