import { MolangVariableMap, system, world } from "@minecraft/server";
import { vfxTick } from "./vfx/vfx";
import { Drops } from "./func/drops";
import { Guidebook } from "./guidebook";
import { weatherSoundTick } from "./vfx/weather_sound";
import { Sapling } from "./func/sapling";
import './vfx/settings';
function init() {
    system.run(internalAutoRunTick);
    let overworld = world.getDimension('overworld');
    overworld.runCommandAsync('function spark/setup');
    Drops.init();
    Sapling.init();
}
function tick() {
    let overworld = world.getDimension("overworld");
    vfxTick();
    weatherSoundTick(overworld);
}
function internalAutoRunTick() {
    system.run(internalAutoRunTick);
    tick();
}
// Dandelion seeds
let placed_dandelion = false;
world.afterEvents.playerPlaceBlock.subscribe((event) => {
    placed_dandelion = true;
}, { blockTypes: ["spark:dandelion_seedhead"] });
world.afterEvents.itemUse.subscribe((event) => {
    if (event.itemStack.typeId == "spark:dandelion_seedhead") {
        if (placed_dandelion) {
            placed_dandelion = false;
            return;
        }
        let player = event.source;
        let variables = new MolangVariableMap();
        variables.setFloat('direction', player.getRotation().y);
        player.dimension.spawnParticle('spark:dandelion_seeds', player.getHeadLocation(), variables);
        player.runCommand('clear @s spark:dandelion_seedhead 0 1');
        player.playSound('sound.spark.realism.dandelion_blow');
    }
});
// guidebook on join
Guidebook.init({
    entityId: 'spark.realism:guide_book',
    itemId: 'spark.realism:guide_book_spawn_egg',
    tag: 'spark.realism:has_joined_before',
    projectName: "realism"
});
init();
